<template>
    <div class="list-view">
        <page-title>
            <el-button
                @click="addRow"
                type="primary"
                icon="el-icon-plus"
                :disabled="fetchingData || downloading"
                class="filter-item"
            >
                新增
            </el-button>
            <el-button
                @click="download('/activityPriorityDocument/excel')"
                icon="el-icon-upload2"
                :loading="downloading"
                :disabled="fetchingData"
                class="filter-item"
            >
                导出
            </el-button>
        </page-title>
        <div class="filters-container">
            <created-at-picker v-model="createdAt" @input="initData" name="创建"></created-at-picker>
            <el-input
                placeholder="搜索..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="initData"
            >
                <el-button @click="initData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
            v-loading="fetchingData"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="name" label="活动名称"> </el-table-column>
            <el-table-column prop="collectionName" label="藏品名称" show-overflow-tooltip="" > </el-table-column>
            <el-table-column prop="collectionId" label="藏品ID"> </el-table-column>
            <el-table-column prop="targetCollectionIdList" label="优先购藏品ID">
                <template v-slot="{ row }">
                    <span v-for="(item, index) in row.targetCollectionIdList" :key="index">{{ item }}，</span>
                </template>
            </el-table-column>
            <el-table-column prop="advancePurchaseTime" label="提前时间（h）"  show-overflow-tooltip="" > </el-table-column>
            <el-table-column prop="advancePurchaseCount" label="购买次数"> </el-table-column>
            <el-table-column prop="itemId" label="凭证类型" show-overflow-tooltip="">
                <template v-slot="{ row }">
                    <span v-if="row.itemId == 0">指定铸造者</span>
                    <span v-if="row.itemId == 1">消耗性全局优先购凭证</span>
                    <span v-if="row.itemId == 2">消耗性指定藏品优先购凭证</span>
                </template>
            </el-table-column>

            <el-table-column prop="createdAt" label="创建时间"></el-table-column>
            <el-table-column label="操作" align="center" fixed="right" width="300">
                <template v-slot="{ row }">
                    <el-button @click="viewDetail(row)" type="warning" size="mini" plain>查看名单</el-button>
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>
                    <el-button @click="resetRow(row)" type="primary" size="mini" plain>重置</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'ActivityList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '', // 搜索字段
            url: '/activityPriorityDocument/all', // 列表接口
            downloading: false,
            createdAt: ''
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            return { search: this.search, query: { del: false, createdAt: this.createdAt } };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        // 新增
        addRow() {
            this.$router.push({
                path: '/preemptionEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        // 编辑
        editRow(row) {
            this.$router.push({
                path: '/preemptionEdit',
                query: {
                    id: row.id
                }
            });
        },
        // 导出
        resetRow(row) {
            // const params = {
            //     ...row
            // }
            this.$alert('确认要重置么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/activityPriorityDocument/reset`, { ...row }, { body: 'json' });
                })
                .then(() => {
                    this.$message.success('重置成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        // 列表 - 删除
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/activityPriorityDocument/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        viewDetail(row){
            this.$router.push({
                path: '/userWareHouseList',
                query:{
                    activityPriorityDocumentId:row.id
                }
            });
        }
    }
};
</script>
<style lang="less" scoped></style>
